package de.fzj.unicore.uas.dsms;

import static org.junit.Assert.fail;

import org.junit.After;
import org.junit.Before;

import pl.edu.icm.dsms.catalogue.db.InitDB;

public class TestDsmsCustomRootDir extends TestDsmsBasics {
	private static final String DATAMAP_CONFIG = "src/test/resources/dcatalogue/datamap.properties";

	private static final String DSMS_ROOT = "dsms/root/dir";

	@Before
	public void setUp() {
		try {
			cleanStorageDirs();
			kernel.setProperty("catalogue.DEFAULT.dsms_root", DSMS_ROOT);

			InitDB.initDB(DATAMAP_CONFIG);
			createSms();
			sms = getSmsClient();
			sms.createDirectory(DSMS_ROOT);
			createCatalogue();
			createDsms();
			dsms = getDsmsClient();
		} catch (Exception e) {
			e.printStackTrace();
			fail("Unable setup test");
		}
	}

	@After
	public void tearDown() {
		try {
			dsms = null;
			destroyDsms();
			destroyCatalogue();
			destroySms();
		} catch (Exception e) {
			e.printStackTrace();
			fail("Unable to tear down");
		}
	}

	public TestDsmsCustomRootDir() throws Exception {
		super();
	}
}
