package de.fzj.unicore.uas.dsms;

import static org.junit.Assert.fail;

import org.junit.After;
import org.junit.Before;
import org.w3.x2005.x08.addressing.EndpointReferenceType;

import de.fzj.unicore.uas.client.StorageClient;

import pl.edu.icm.dsms.catalogue.db.InitDB;

public class TestDsmsFactoryBasics extends TestDsmsBasics {
	private String dataMap = "src/test/resources/dcatalogue/datamap.properties";

	@Before
	public void setUp() {
		try {
			kernel.setProperty("uas.storagefactory.storagetypes", "DSMS DEFAULT");
			
			InitDB.initDB(dataMap);
			createSms();
			createFactory();
			createCatalogue();

			EndpointReferenceType epr = getFactoryClient().createSMS("DSMS", "DynamicDSMS", lifeTime()).getEPR();
			this.dsms = new StorageClient(epr, getSecurityPropertiesWithTd(DEFAULT_CLIENT_ALIAS, epr));
			sms = getSmsClient();
		} catch (Exception e) {
			e.printStackTrace();
			fail("Unable setup test");
		}
	}

	@After
	public void tearDown() {
		try {
			dsms = null;

			destroySms();
			destroyCatalogue();
			destroyFactory();
		} catch (Exception e) {
			e.printStackTrace();
			fail("Unable to tear down");
		}
	}

	public TestDsmsFactoryBasics() throws Exception {
		super();
	}
}
