package de.fzj.unicore.uas.dsms;

import static org.junit.Assert.fail;

import java.io.File;
import java.io.IOException;

import org.apache.commons.io.FileUtils;
import org.apache.commons.io.IOUtils;
import org.junit.After;
import org.junit.Before;
import org.junit.Ignore;
import org.junit.Test;
import org.w3.x2005.x08.addressing.EndpointReferenceType;

import de.fzj.unicore.uas.client.StorageClient;

import pl.edu.icm.dsms.catalogue.db.InitDB;

public class TestDsmsWithTsf extends TestDsmsBasics {
	private String dataMap = "src/test/resources/dcatalogue/datamap.properties";

	@Before
	public void setUp() {
		try {
			kernel.setProperty("catalogue.DEFAULT.tsf",
					"https://localhost:65321/services/TargetSystemFactoryService?res=default_target_system_factory");
			kernel.setProperty("catalogue.DEFAULT.tss_storage_name", "TSS_STORAGE");
			kernel.setProperty("uas.storagefactory.storagetypes", "DSMS");
			
			InitDB.initDB(dataMap);
			createTsf();
			File tssStorage=new File("target/unicorex-test/tss_storage");
			FileUtils.deleteQuietly(tssStorage);
			tssStorage.mkdirs();
			createFactory();
			createCatalogue();

			EndpointReferenceType epr = getFactoryClient().createSMS("DSMS", "DynamicDSMS", lifeTime()).getEPR();
			this.dsms = new StorageClient(epr, getSecurityPropertiesWithTd(DEFAULT_CLIENT_ALIAS, epr));			
		} catch (Exception e) {
			e.printStackTrace();
			fail("Unable setup test");
		}
	}

	@After
	public void tearDown() {
		try {
			dsms = null;

			destroyCatalogue();
			destroyFactory();
			destroyTsf();
		} catch (Exception e) {
			e.printStackTrace();
			fail("Unable to tear down");
		}
	}

	public TestDsmsWithTsf() throws Exception {
		super();
	}
	
	@Test
	@Ignore
	@Override
	public void testRecv() throws IOException, Exception {
	}
	
	@Test
	@Ignore
	@Override
	public void testSend() throws IOException, Exception {
	}
	

	@Test
	@Ignore
	@Override
	public void testFreeSpace() throws Exception {
	}
}
